config/routes.rb
Rails.application.routes.draw do
  resources :conversations do
    resource :conversation_user
    resources :messages
  end
  resources :reservations, path_names: { new: 'new/:location_id' }
  resources :favoris, path_names: { new: 'new/:location_id' }
  resources :avis, path_names: { new: 'new/:location_id' }
  resources :categories
  resources :equipements, path_names: { new: 'new/:location_id' }
  devise_for :users
  resources :locations
  resources :searches
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: "locations#index"
end

app/models/category.rb
class Category < ApplicationRecord
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :authenticate_user!
  before_action :set_category, only: %i[ show edit update destroy ]

  # GET /categories or /categories.json
  def index
    @categories = Category.all
  end

  # GET /categories/1 or /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories or /categories.json
  def create
    @categories = Category.all
    @category = Category.new(category_params)

    respond_to do |format|
      if @category.save
        format.html { render :index, notice: "La Catégorie vient d'être créé." }
        format.json { render :show, status: :created, location: @categories }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1 or /categories/1.json
  def update
    @categories = Category.all
    respond_to do |format|
      if @category.update(category_params)
        format.html { render :index, notice: "La Catégorie vient d'être modifié." }
        format.json { render :show, status: :ok, location: @categories }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1 or /categories/1.json
  def destroy
    @category.destroy

    respond_to do |format|
      format.html { redirect_to categories_url, notice: "La Catégorie a été supprimé." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def category_params
      params.require(:category).permit(:nom)
    end
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/_form.html.erb
<%= form_with(model: category) do |form| %>
  <% if category.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(category.errors.count, "error") %> prohibited this category from being saved:</h2>

      <ul>
        <% category.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :nom %>
    <%= form.text_field :nom %>
  </div>

  <div class="actions">
    <%= link_to 'Annuler', :back, class:"btn btn-danger", style:"color:white" %>
    <%= form.submit "Enregistrer", class: 'btn btn-success' %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h1>Edition catégorie</h1>
<%= render 'form', category: @category %>

app/views/categories/index.html.erb
<h1>Categories</h1>
<%= link_to 'Nouvelle catégorie', new_category_path, class:"btn btn-success", style:"color:white" %>
<div class="card-deck mt-4">
  <div class="row">
    <% @categories.each do |category| %>
    <div class="col" >
      <div class="card mb-4"  style="width: 18rem">
        <div class="card-body">
          <h5 class="card-title" style="display: block; overflow: hidden; white-space: nowrap; text-overflow: ellipsis;"><%= category.nom %></h5>
          <p class="card-text">id : <%= category.id %> </p>
        </div>
        <div class="card-footer">
          <div class="row" >
            <div class="col" >
              <%= link_to 'Modifier', edit_category_path(category),class: "btn btn-primary  btn-block", style: "color: white" %>
            </div>
            <div class="col"><!--extra div--></div>
            <div class="col" >
              <%= link_to 'Supprimer', category, method: :delete, data: { confirm: 'Êtes vous sûr ?' },class: "btn btn-danger", style: "color: white" %>
            </div>
          </div>
        </div>
      </div>
    </div>
  <% end %>
  </div>
</div>

app/views/categories/new.html.erb
<h1>Nouvelle catégorie</h1>

<%= render 'form', category: @category %>

app/views/categories/show.html.erb
<h1>Voir réservation</h1>
<p>
  <strong>Nom:</strong>
  <%= @category.nom %>
</p>


<%= link_to 'Retour', :back, class:"btn btn-danger", style:"color:white" %>
<%= link_to 'Edit', edit_category_path(@category), class:"btn btn-warning " %>